<template>
  <q-card>
    <q-card-section class="c-row items-center bg-primary text-white">
      <div class="text-24px">
        職員清單
      </div>
      <q-icon
        class="ml-10px cursor-pointer"
        name="add_circle"
        size="30px"
        @click="addStaffMember"
      />
    </q-card-section>
    <q-card-section class="!p-0px">
      <div class="row flex-center py-5px bg-gray-50">
        <!-- 姓名-->
        <div class="col mx-5px">
          姓名
        </div><!-- 工作班別-->
        <div
          id="jobType"
          class="col-3 mx-5px"
        >
          工作班別<q-tooltip
            anchor="top middle"
            self="bottom middle"
          >
            此員工可工作的班別，複選。
          </q-tooltip>
          <q-icon
            class="cursor-pointer"
            name="filter_alt"
            :color="filter.jobType.length === 0 ? 'grey' : 'red'"
          >
            <q-menu target="#jobType">
              <q-list>
                <q-item
                  clickable
                  @click="filter.jobType.length = 0"
                >
                  <q-item-section>清空過濾選項</q-item-section>
                </q-item>
                <q-separator />
                <q-item
                  v-for="item in jobTypes"
                  :key="item.name"
                  tag="label"
                >
                  <q-item-section
                    side
                    top
                  >
                    <q-checkbox
                      v-model="filter.jobType"
                      :val="item"
                    />
                  </q-item-section>
                  <q-item-section>
                    <q-item-label>{{ item.name }}</q-item-label>
                  </q-item-section>
                </q-item>
              </q-list>
            </q-menu>
          </q-icon>
        </div><!-- 資格-->
        <div
          id="qualification"
          class="col-3 mx-5px"
        >
          資格<q-tooltip
            anchor="top middle"
            self="bottom middle"
          >
            表示此員工是否擁有某些特定資格，複選。
          </q-tooltip>
          <q-icon
            class="cursor-pointer"
            name="filter_alt"
            :color="filter.qualification.length === 0 ? 'grey' : 'red'"
          >
            <q-menu target="#qualification">
              <q-list>
                <q-item
                  clickable
                  @click="filter.qualification.length = 0"
                >
                  <q-item-section>清空過濾選項</q-item-section>
                </q-item>
                <q-separator />
                <q-item
                  v-for="item in qualifications"
                  :key="item.name"
                  tag="label"
                >
                  <q-item-section
                    side
                    top
                  >
                    <q-checkbox
                      v-model="filter.qualification"
                      :val="item"
                    />
                  </q-item-section>
                  <q-item-section>
                    <q-item-label>{{ item.name }}</q-item-label>
                  </q-item-section>
                </q-item>
              </q-list>
            </q-menu>
          </q-icon>
        </div><!-- 休假-->
        <div class="col-1 mx-5px">
          休假<q-tooltip
            anchor="top middle"
            self="bottom middle"
          >
            點擊後開啟日期工具
          </q-tooltip>
        </div><!-- 工具列-->
        <div class="px-5px pr-10px">
          <q-icon
            name="settings"
            size="18px"
            color="grey-5"
          />
          <q-menu>
            <q-list style="min-width: 100px">
              <q-item
                v-close-popup
                clickable
                @click="clearStaff"
              >
                <q-item-section>全部刪除</q-item-section>
              </q-item>
            </q-list>
          </q-menu>
        </div>
      </div>
      <q-virtual-scroll
        style="height: 600px"
        :items="filteredStaff"
      >
        <template #default="{ item: member, index: i }">
          <div class="row flex-center py-8px">
            <div class="col mx-5px">
              <q-input
                v-model="member.name"
                dense
                filled
              />
            </div>
            <div class="col-3 mx-5px">
              <select-chip
                v-model="member.jobTypes"
                :options="jobTypes"
                :always-hide-popup="true"
              />
            </div>
            <div class="col-3 mx-5px">
              <select-chip
                v-model="member.qualifications"
                :options="qualifications"
                :always-hide-popup="true"
              />
            </div>
            <div class="col-1 mx-5px">
              <q-icon
                name="event_note"
                size="24px"
                color="grey-6"
              >
                <q-popup-proxy>
                  <picker-date-holiday :member="member" />
                </q-popup-proxy>
              </q-icon>
            </div>
            <div class="px-5px pr-10px">
              <q-icon
                name="settings"
                size="24px"
                color="grey-6"
              />
              <q-menu>
                <q-list style="min-width: 100px">
                  <q-item
                    v-close-popup
                    clickable
                    @click="removeStaffMember(i)"
                  >
                    <q-item-section>刪除此職員</q-item-section>
                  </q-item>
                </q-list>
              </q-menu>
            </div>
          </div>
        </template>
      </q-virtual-scroll>
    </q-card-section>
  </q-card>
</template>

<script lang='ts' setup>
import { computed, reactive, ref, watch } from 'vue';
import { cloneDeep } from 'lodash-es';
import { Qualification, JobType, StaffMember } from '../types/main.type';

import PickerDateHoliday from '../components/picker-date-holiday.vue';
import SelectChip from './select-chip.vue';

import { useMainStore } from '../store/main.store';

interface Filter {
  jobType: Qualification[];
  qualification: JobType[];
}

const store = useMainStore();

const filter = reactive<Filter>({
  jobType: [],
  qualification: [],
});

const staff = ref(cloneDeep(store.staff) as StaffMember[]);
watch(
  staff,
  (value) => {
    store.setStaff(value);
  },
  { deep: true }
);

const filteredStaff = computed(() => {
  return staff.value.filter((member) => {
    let result = true;

    if (filter.jobType.length !== 0) {
      result &&= filter.jobType.every((jobType) => {
        return member.jobTypes.some(
          (memberJobType) => memberJobType.name === jobType.name
        );
      });
    }

    if (filter.qualification.length !== 0) {
      result &&= filter.qualification.every((qualification) => {
        return member.qualifications.some(
          (memberQualification) =>
            memberQualification.name === qualification.name
        );
      });
    }

    return result;
  });
});

const addStaffMember = () => {
  const member: StaffMember = {
    enable: true,
    name: '',
    codename: '',
    description: '',
    qualifications: [],
    jobTypes: [],
  };
  staff.value.push(member);
};
const removeStaffMember = (i: number) => {
  staff.value.splice(i, 1);
};
const clearStaff = () => {
  staff.value = [];
};

const qualifications = computed(() => store.qualifications);
const jobTypes = computed(() => store.jobTypes);
</script>

<style scoped lang='sass'>

.row
  text-align: center
</style>
